\sectionA{Typing Rules}
\label{section:typing-rules}

\iftechreport
   The typing rules for \fir{} terms are presented in this section as a set of
   inference rules.  Only syntactically valid terms are covered by these rules.
   Each rule consists of a judgment from Figure~\ref{figure:judgments} as the
   conclusion, and a list of judgments and other ``side-conditions'' (such as
   $i\in\tyint$) as premises.

   % Emre: We mentioned this before in the syntax section, but it's
   %       probably good to repeat it here, since the tech report
   %       is long.
   Recall that we use the notation $\lvec{v\subi}{\varbase}{\varbound}$ to denote
   the vector $\cvec{v\subi}{\varbase}{\varbound}$.  The index variable is
   implicitly $\xxxdefaultindex$.  An alternate notation ${\setindex{j}
   \lvec{v\subi}{\varbase}{\varbound}}$ explicitly uses a different index
   variable $j$. We also use the notation
   $\lvec{u\subi/\alpha\subi}{\varbase}{\varbound}$
   to represent a vector of type substitutions.
\fi

We use the shorthand $\withgenvtype \lvec{J\subi}{\varbase}{\varbound}$ to
denote a list of judgments.  This is equivalent to listing all judgments
$\withgenvtype{J_1}$, $\ldots$, $\withgenvtype{J_n}$. When $n = 0$, this
notation expands to no judgments.
\tronly{The notation $\lvec{\genv\subi \vdash J\subi}{\varbase}{\varbound}$
        is similar.}

We use the notation $(\genvtype_1,\genvtype_2)\xas\genvtype$ to indicate that
the context $\genvtype$ is the same as $(\genvtype_1,\genvtype_2)$ throughout
an inference or reduction rule.

\ifpaper
   For this \papername, we describe only the subscript operations that access
   unsafe data, and rules for special-calls, which implement process migration
   and transactions.  The complete type system and its operational semantics are
   described in the technical report~\cite{fir:tech-report1}.
\fi

%
% Here begins a long block of rules that we don't include in POPL.
% This \iftechreport ends at the beginning of the special-call rules.
%
\iftechreport

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Well-formedness of contexts
%
\sectionB{Context well-formedness}
\label{section:context-wf}

\begin{block}
\setalttypename{\typeorig}
The \refmath{WF-Empty-Context} rule is the axiom rule for all type proofs and
says that the empty context is well-formed.

\minferrule\wfemptycontext[WF-Empty-Context]
   {\withenv{}{\diamond}}
   {}

The next three rules are for proving arbitrary judgments $J$ by thinning declarations from the
context.  We assume implicitly that sequents are closed.  For example, the \refmath{Thin-Type} rule
can only be applied if $\tyvar$ is not free in $\genvtype$.

\minferrule\thintype[Thin-Type]
   {\withgenvtypeand{\vdef{\tyvar}{\kindname}}{\conclname}}
   {\withgenvtype{\conclname}}

\minferrule\thinvar[Thin-Var]
   {\withgenvtypeand{\vdef{v}{\alttypename}}{\conclname}}
   {\withgenvtype{\conclname} & \withgenvtype{\tymember{\alttypename}{\Type}}}

\minferrule\thinglobal[Thin-Global]
   {\withgenvtypeand{\vdef{l}{\alttypename}}{\conclname}}
   {\withgenvtype{\conclname} & \withgenvtype{\tymember{\alttypename}{\Type}}}

The following three rules are for proving arbitrary judgments $J$ from context
\emph{definitions}.  The judgment $J$ is true if it can be proved with only
the declaration, and if the value being defined is well-typed.

\minferrule\thintypedef[Thin-Type-Def]
   {\withgenvtypeand{\hdef{\tyvar}{\kindname}{\tydef}}{\conclname}}
   {\withgenvtypeand{\vdef{\tyvar}{\kindname}}{\tymember{\tydef}{\kindname}}
    & \withgenvtypeand{\vdef{\tyvar}{\kindname}}{\conclname}}

\minferrule\thinvardef[Thin-Var-Def]
   {\withgenvtypeand{\hdef{v}{\alttypename}{\blockname}}{\conclname}}
   {\withgenvtypeand{\vdef{v}{\alttypename}}{\tymember{\blockname}{\alttypename}}
    & \withgenvtypeand{\vdef{v}{\alttypename}}{\conclname}}

\minferrule\thinglobaldef[Thin-Global-Def]
   {\withgenvtypeand{\hdef{l}{\alttypename}{\heapname}}{\conclname}}
   {\withgenvtypeand{\vdef{l}{\alttypename}}{\tymember{\heapname}{\alttypename}}
    & \withgenvtypeand{\vdef{l}{\alttypename}}{\conclname}}
\end{block}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Type equality rules
%

\sectionB{Type equality and structural rules}

Type equality is an equivalence relation.  If a type constructor is declared
as part of the environment, the reflexive form reduces to context
well-formedness.

\begin{block}
\shortformfalse
\minferrule\wfsttyvar[Ty-Ref]
   {\withgenvtypeand{\vdef{\tyvar}{\kindname}}{\tymember{\tyvar}{\kindname}}}
   {\withgenvtypeand{\vdef{\tyvar}{\kindname}}{\diamond}}
\end{block}

The symmetric and transitive forms have the usual definitions.

\minferrule\tysym[Ty-Sym]
   {\withgenvtype{\tyequal{\typename_1}{\typename_2}{k}}}
   {\withgenvtype{\tyequal{\typename_2}{\typename_1}{k}}}

\minferrule\tytrans[Ty-Trans]
   {\withgenvtype{\tyequal{\typename_1}{\typename_3}{k}}}
   {\withgenvtype{\tyequal{\typename_1}{\typename_2}{k}}
    & \withgenvtype{\tyequal{\typename_2}{\typename_3}{k}}}

If two types are equal, they contain the same elements.  In the following rule, the term $\termname$
represents an atom $a$, an expression $e$, a store value $b$, or a global label $\xlabel$.

\minferrule\tysubst[Ty-Subst]
   {\withgenvtype{\termname : \typename}}
   {\withgenvtype{\tyequal{\typename}{\alttypename}{k}}
    & \withgenvtype{\termname : \alttypename}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Application and elimination of type equality rules
%
\sectionB{Application and elimination type equality rules}

There are two main rules for type equality of type applications.  Two type
applications are equal if they use the same type definition and they have
equal type parameters.

\begin{block}
\shortformfalse
\minferrule\tyapplyone[Ty-Apply-1]
   {\withgenvtype{\tymember{\tyapply{\tyvar}{\cvec{\typename\subi\supeq}{\polybase}{\polybound}}}{\skindname}}}
   {\withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\polybound}}
    & \withgenvtype{\shortformtrue \tymember{\tyvar}{\Typefun{\polybound}{\skindname}}}}
\end{block}

If the context contains a type definition, the type in a type application may
be expanded.

\minferrule\tyapplytwo[Ty-Apply-2]
   {\withenv{(\genvtype', \hdef{\tyvar}{\kindname}{\tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{u_1}}) \xas \genvtype}
                    {\tyequal{\tyapply{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}}{u_2}{\skindname}}}
   {\withgenvtype{\tyequal{u_1[\lvec{t\subi / \alpha\subi}{\polybase}{\polybound}]}{u_2}{\skindname}}
    & \withgenvtype{\tymember{\tyapply{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}}{\skindname}}}

The type projection $\typroject{v}{i}$ represents a type argument packed in a
value with existential type.  If $v$ is a value of type
$\tyexists{\setindex{j} \cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{t'}$, then
$\typroject{v}{i}$ represents the type $\alpha_i$.  If the value is defined as
$\atomtypack{u}{v'}{\cvec{u\subi}{\polybasezero}{\polyboundzero}}$, then the type
$\typroject{v}{i}$ can be reduced to $u_i$.

\minferrule\typrojequal[Ty-Project-Equal]
   {\withenv{(\genvtype', \hdef{v}{\tyexists{\setindex{j}\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{\typename'}}
                       {\atomtypack{u}{v'}{\cvec{u\subi}{\polybasezero}{\polyboundzero}}}) \xas \genv}
                {\tyequal{\typroject{v}{i}}{\typename}{\Smalltype}}}
   {i \in \mkset{\polybasezero \ldots \polyboundzero}
    & \withgenvtype{\tyequal{u_i}{\typename}{\Smalltype}}}

\nocomment{JDS:  What if $v$ is a pointer to a typack?  This isn't creating
         two separate typacks which happen to have the same types; this
         is two pointers to the exact same typack.  What happens then?\\
         Emre: I know we discussed this one before.  I think the solution
         was something along the lines of: we could write down a rule or
         something to follow ``a chain'' down until we got to the actual
         definition or something.\\
         In any event, I say that at this point, we should just ignore this
         issue.  There's going to be other mistakes we'll miss, probably,
         and we could, at some later time, (in theory) publish a list
         of errata.\\
         JDS:  I think we cannot ignore this in good conscience (shrug).
         We can certainly fix this with the addition of one new rule, but
         I do not know offhand how many proofs that extra rule will impact.
         Is it as simple as adding a reference to the new rule everywhere
         the Ty-Project-Equal rule occurs?\\
         Emre: Jason's solution: v : t = v' never happens in the actual
         system.  We change the definition of fully-defined context (or
         whatever) to say such a context can't have v : t = v'.  Then there's
         the one lemma about fully defined / well-formed contexts or
         whatever that needs to be updated.  This is supposed to solve
         the problem.  Thoughts?\\
         JDS:  I don't follow.  When one variable is a pointer to another
         location, don't you use the $v:t = v'$ notation?  E.g. I allocate
         a tuple $v':t = (a_1\ldots a_n)$, and I want $v$ to be a pointer
         to the \emph{same} tuple (not a copy of the tuple), then I must
         use $v:t = v'$ yes?  If we disallow $v:t = v'$ then how do I express
         that two variables point to the same actual object?\\
         If we say that this is disallowed only for the case of projection,
         then it seems fishy to me...\\
         JDS: This was addressed...}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Constructor equality
%
\sectionB{Constructor equality}

The following five rules present the type equality judgments for \fir{} type
constructors.

\begin{block}
\shortformfalse

Two type lists are equal if they are pointwise equal.  The premise
$\withgenvtype{\diamond}$ is required in \refmath{WF-TypeList} since it can be
the case that $n=0$, i.e.~the type lists are empty.

\minferrule\wftypelist[WF-TypeList]
   {\withgenvtype{\tymember{\xvector{\cvec{t\subi\supeq}{\varbase}{\varbound}}}{\Smalltype}}}
   {\withgenvtype{\lvec{\tymember{t\subi\supeq}{\Smalltype}}{\varbase}{\varbound}}
    & \withgenvtype{\diamond}}

By default, type definitions are parameterized; the case $m=0$ corresponds to
a non-parameterized definition.  Two definitions are equal if the resulting
types are equal when instantiated with the same types.
Note that we use implicit alpha renaming in this
rule to require that the two types have the same binding variables.

\minferrule\wftydef[WF-Tydef]
   {\withgenvtype{\tymember{\tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{\stydef\supeq}}}{\Typefun{\polybound}{\skindname}}}
   {\withgenvtypeand{\vvecdef{\alpha\subi}{\Smalltype}{\polybase}{\polybound}}{\tymember{\stydef\supeq}{\skindname}}}

The next three rules allow progress to be made on proving the premise of
\refmath{WF-Tydef}. They cover the cases in which $\stydef$ is a union or
frame type\footnote{The cases for a general type $t$ are covered in
Section~\ref{section:type-equality}.}. All three rules require the context
well-formedness premise $\withgenvtype{\diamond}$ since it can be the case
that $n=0$.

The union space $\left(\plusvec{\vec{t}\subi}{\varbase}{\varbound} \right)$ is
the disjoint union of several tuple\footnote{The use of ``tuple'' in this
context should not be confused with the tuple type
$\tytuple{\tupleclass}{\cvec{\typename\subi}{\varbase}{\varbound}}$.} spaces
(that is, a union is like a set of tagged tuples).  Two union spaces are equal
if they have the same number of tuple spaces, and the tuple spaces are equal.

\minferrule\wftydefunion[WF-TydefUnion]
   {\withgenvtype{\tymember{\left(\plusvec{\overrightarrow{t\subi\supeq}}{\varbase}{\varbound}\right)}{\Uniontype{\varbound}}}}
   {\withgenvtype{\lvec{\tymember{\overrightarrow{t\subi\supeq}}{\Smalltype}}{\varbase}{\varbound}}
    & \withgenvtype{\diamond}}

Frames are doubly nested records. The frame type
$\tyframerecord{\cvec{\framelabel{f}\subi : R\subi}{\varbase}{\varbound}}$
declares sub-records named $\framelabel{f}_i$ with record type $R_i$, and the
record type
$\tyframerecord{\cvec{\framelabel{r}\subi : t\subi}{\varbase}{\varbound}}$
declares fields named $\framelabel{r}_i$ with type $t_i$.  Two record types
are equal if they have the same number of fields with the same labels, and the
corresponding labels have equal types.

\minferrule\wftydefframe[WF-TydefFrame]
   {\withgenvtype{\tymember{\tyframerecord{\cvec{\framelabel{f}\subi : \tyrecordname\subi\supeq}{\varbase}{\varbound}}}{\Frametype}}}
   {\withgenvtype{\lvec{\tymember{\tyrecordname\subi\supeq}{\Recordtype}}{\varbase}{\varbound}}
    & \withgenvtype{\diamond}}

\minferrule\wftydefrecord[WF-TydefRecord]
   {\withgenvtype{\tymember{\tyrecord{\cvec{\framelabel{r}\subi : \typename\subi\supeq}{\varbase}{\varbound}}}{\Recordtype}}}
   {\withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Type}}{\varbase}{\varbound}}
    & \withgenvtype{\diamond}}

\end{block}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Store typing rules
%
\sectionB{Store typing rules}

In conjunction with the atom typing rules (Section~\ref{section:type-atoms}),
the following rules specify the typing rules for store values $b$.  They allow
progress to be made on the premise of \refmath{Thin-Var-Def}.

Arrays are well-typed if each element has the same type and the type
of the array is well-formed.  The rule for tuples is similar except that the
types of the elements may differ.

\minferrule\tystorearray[Ty-StoreArray]
   {\withgenvtype \storetuple{\cvec{a\subi}{\varbase}{\varbound}} : \tyarray{t}}
   {\withgenvtype \lvec{a\subi : t}{\varbase}{\varbound} &
    \withgenvtype \tyarray{t} : \Type}

\minferrule\tystoretuple[Ty-StoreTuple]
   {\withgenvtype \storetuple{\cvec{a\subi}{\varbase}{\varbound}} : \tytuple{\tupleclass}{\cvec{t\subi}{\varbase}{\varbound}}}
   {\withgenvtype \lvec{a\subi : t\subi}{\varbase}{\varbound} &
    \withgenvtype \tytuple{\tupleclass}{\cvec{t\subi}{\varbase}{\varbound}} : \Type}

In general, union definitions are polymorphic; the type
$\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}$ represents the
union, named $\tyvar$, instantiated at types
$\cvec{t'\subi}{\polybase}{\polybound}$.  The type
$\tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}{\mkset{j}}$ is case
$j$ of this union.
%
The value $\storeunion{\tyvar}{j}{\cvec{a\subi}{\polybase}{k}}$ belongs to
case $j$ of a union type
$\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}$ if all of the
following hold:
%
\begin{itemize}
   \item The type $\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}$
         is a valid union type $\plusvec{\vec{t}\subi}{\varbase}{\varbound}$.
   \item The case $\vec{t}_j$ is the tuple space $\xvector{\cvec{u\subi}{\polybase}{k}}$.
   \item For each $i \in \mkset{1, \ldots, k}$, the value $a_i$ has type $u_i$.
\end{itemize}

\minferrule\tystoreunion[Ty-StoreUnion]
   {\withgenvtype{\storeunion{\tyvar}{j}{\cvec{a\subi}{\polybase}{k}} : \tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}{\mkset{j}}}}
   {\begin{array}{l}
       \withgenvtypeand{\hvecdef{\alpha\subi}{\Smalltype}{t\subi'}{\polybase}{\polybound}}{\lvec{a\subi : u\subi}{\polybase}{k}}\\
       \withgenvtype{\tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}{\mkset{j}} : \Type}\\
       \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}}
                             {\plusvec{\vec{t}\subi}{\varbasezero}{j-1}
                              + \xvector{\cvec{u\subi}{\polybase}{k}}
                              + \plusvec{\vec{t}\subi}{j+1}{\varboundzero}}
                             {\Uniontype{\varbound}}}
    \end{array}}

Functions are also polymorphic by default.  Each function
$\tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{\storefun{\cvec{v\subi}{\varbase}{\varbound}}{e}}$
has type parameters $\cvec{\alpha\subi}{\polybase}{\polybound}$, actual
parameters $\cvec{v\subi}{\varbase}{\varbound}$, and body $e$.  The function
has type
$\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}}$
if, given arbitrary types $\cvec{\alpha\subi}{\polybase}{\polybound}$, and
values $\cvec{v\subi\colon u\subi}{\varbase}{\varbound}$, the body $e$ has type
$t$.

\minferrule\tystorefunmono[Ty-StoreFun-Mono]
   {\withgenvtype{\tymember{\storefun{\cvec{v\subi}{\varbase}{\varbound}}{e}}{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{\typename}}}}
   {\withgenvtypeand{{\vvecdef{v\subi}{u\subi}{\varbase}{\varbound}}}{e : \typename}}

\minferrule\tystorefunpoly[Ty-StoreFun-Poly]
   {\withgenvtype{\tymember{\tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{\storefun{\cvec{v\subi}{\varbase}{\varbound}}{e}}}{\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}}}}}
   {\withgenvtypeand{\vvecdef{\alpha\subi}{\Smalltype}{\polybase}{\polybound}}{\tymember{\storefun{\cvec{v\subi}{\varbase}{\varbound}}{e}}{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}}}}

Rawdata values are abstract.  A value $\storedata{\xdata}$ always has type
$\tyrawdata$.

\minferrule\tystoredata[Ty-StoreData]
   {\withgenvtype{\tymember{\storedata{\xdata}}{\tyrawdata}}}
   {\withgenvtype{\diamond}}

Frames are similar to rawdata values.  The value
$\storeframe{\xdata}{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}$ is an
abstract value of type
$\tyframe{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}$ if the frame type is
well-formed.

\minferrule\tystoreframe[Ty-StoreFrame]
   {\withgenvtype{\tymember{\storeframe{\xdata}{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}
                           {\tyframe{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}}}
   {\withgenvtype{\tymember
                     {\tyapply{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}
                     {\Frametype}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Type equality
%
% When is a type well-formed.
% For the actual rules we do not want the short form.
%
\sectionB{Type equality}
\label{section:type-equality}

\begin{block}
\shortformfalse

Type well-formedness is ensured using the type equality judgments
$\withgenvtype{\tymember{\typename\subeq}{\Type}}$ and
$\withgenvtype{\tymember{\typename\subeq}{\Smalltype}}$.  Recall that
$\Smalltype$ is used to denote types that are small.  Since the
\refmath{WF-SmallType} rule allows any $\Smalltype$ type to be used as a
normal type, equality judgments are given for the $\Smalltype$ kind whenever
possible.

\minferrule\wfsmalltype[WF-SmallType]
   {\withgenvtype{\tymember{\typename\subeq}{\Type}}}
   {\withgenvtype{\tymember{\typename\subeq}{\Smalltype}}}

Enumeration types are restricted to a maximum size of $\maxenum$, which is a
predefined small positive integer\footnote{Enumeration values are restricted
to small values to reduce the number of cases where a numerical value is
mistaken as a pointer index during garbage collection; all pointer indices
must be larger than $\maxenum$.  This reduces the likelihood that a dead block
will be marked live by the garbage collector.}.

\minferrule\wfsttyenum[WF-ST-TyEnum]
   {\withgenvtype{\tymember{\tyenum{i}}{\Smalltype}}}
   {i \in \mkset{0\ldots \maxenum - 1}
    & \withgenvtype{\diamond}}

Type equality judgments for numeric \fir{} types are straightforward.  Note
that $\tyrawint{\pre}{\sign}$ and $\tyfloat{\fpre}$ cannot be used as
$\Smalltype$ types.

\minferrule\wfsttyint[WF-ST-TyInt]
   {\withgenvtype{\tymember{\tyint}{\Smalltype}}}
   {\withgenvtype{\diamond}}

\minferrule\wftyrawint[WF-TyRawInt]
   {\withgenvtype \tymember{\tyrawint{\pre}{\sign}}{\Type}}
   {\withgenvtype{\diamond} }

\minferrule\wftyfloat[WF-TyFloat]
   {\withgenvtype \tymember{\tyfloat{\fpre}}{\Type}}
   {\withgenvtype{\diamond} }

For the type
$\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\intset}$, $\intset$
denotes a subset of the cases of the (polymorphic) union type named by
$\tyvar$ instantiated at types $\cvec{t\subi}{\polybase}{\polybound}$.  For
two union types to be equal, they must have the same name, and their type
arguments must also be equal.

\minferrule\wfsttyunion[WF-ST-TyUnion]
   {\withgenv{\tymember{\tyunion{\tyvar}{\cvec{\typename\subi\supeq}{\polybase}{\polybound}}{\intset}}{\Smalltype}}}
   {\intset \subseteq \mkset{0 \ldots n-1}
    & \withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\polybound}}
    & \withgenvtype{{\shortformtrue \tymember{\tyapply{\tyvar}{\cvec{t\subi\eqright{^2}}{\polybase}{\polybound}}}{\Uniontype{\varbound}}}}}

Two tuple types are equal if they are pointwise equal (their projections have
the same types).  The context well-formedness premise
$\withgenvtype{\diamond}$ is required in \refmath{WF-ST-TyTuple-Normal} since
it can be the case that $n=0$.

\minferrule\wfsttytuplenormal[WF-ST-TyTuple-Normal]
   {\withgenvtype{\tymember{\tytuple{\normaltuple}{\cvec{\typename\subi\supeq}{\varbase}{\varbound}}}{\Smalltype}}}
   {\withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\varbase}{\varbound}}
    & \withgenvtype{\diamond}}

The \boxedtuple{} tuples are used to ``pack'' non-$\Smalltype$ types in a form
that has kind $\Smalltype$.  The tuple must have arity exactly one.

\minferrule\wfsttytupleboxed[WF-ST-TyTuple-Boxed]
   {\withgenvtype{\tymember{\tytuple{\boxedtuple}{\typename\subeq}}{\Smalltype}}}
   {\withgenvtype{\tymember{t\subeq}{\Type}}}

An array is just like a tuple, except that all the elements must have the same
type, and the arity is not defined by the type.  Two array types are equal if
their element types are equal.

\minferrule\wfsttyarray[WF-ST-TyArray]
   {\withgenvtype{\tymember{\tyarray{\typename\subeq}}{\Smalltype}}}
   {\withgenvtype{\tymember{\typename\subeq}{\Type}}}

``Rawdata'' is the opaque data space used to represent C heap data.

\minferrule\wfsttyrawdata[WF-ST-TyRawData]
   {\withgenvtype{\tymember{\tyrawdata}{\Smalltype}}}
   {\withgenvtype{\diamond}}

For two frame types to be equal, they must have the same frame name, and their
type arguments must also be equal.

\minferrule\wfsttyframe[WF-ST-TyFrame]
   {\withgenv{\tymember{\tyframe{\tyvar}{\cvec{\typename\subi\supeq}{\polybase}{\polybound}}}{\Smalltype}}}
   {\withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\polybound}}
    & \withgenvtype{{\shortformtrue \tymember{\tyapply{\tyvar}{\cvec{t\subi\eqright{^2}}{\polybase}{\polybound}}}{\Frametype}}}}

Two existential types are equal if they have the same arity, and their
abstracted types are equal.  Note that we use implicit alpha renaming in this
rule to require that the two types have the same binding variables.

\minferrule\wfsttyexists[WF-ST-TyExists]
   {\withgenvtype{\tymember{\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename\subeq}}{\Smalltype}}}
   {\withgenvtypeand{\vvecdef{\alpha\subi}{\Smalltype}{\polybase}{\polybound}}{\tymember{\typename\subeq}{\Type}}}

A type projection $\typroject{v}{i}$ is well-formed if $v$ has existential
type $\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{t}$, and $i$ is a
valid index for one of the type parameters $\alpha_i$.

\minferrule\wfsttyproject[WF-ST-TyProject]
   {\withgenv{\tymember{\typroject{v}{i}}{\Smalltype}}}
   {i \in \mkset{\polybasezero\ldots\polyboundzero}
    & \withgenvtype{\shortformtrue \tymember{v}{\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{\typename}}}}

The only values that are universally polymorphic are functions, corresponding
to value restriction~\cite{ullman:sml}.  We enforce the value
restriction explicitly in the well-formedness rule for
$\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}$ by requiring $t$ to be
a function type.  Again, we use implicit alpha renaming to require that the
two types use the same binding sequence.

\minferrule\wfsttyfunmono[WF-ST-TyFun-Mono]
   {\withgenvtype{\tymember{(\tyfun{\argvec{\typename\subi\supeq}{\varbase}{\varbound}}{\alttypename\supeq})}{\Smalltype}}}
   {\withgenvtype{\lvec{\tymember{\typename\subi\supeq}{\Type}}{\varbase}{\varbound}}
    & \withgenvtype{\tymember{\alttypename\supeq}{\Type}}}

\minferrule\wfsttyfunpoly[WF-ST-TyFun-Poly]
   {\withgenvtype{\tymember{\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{(\tyfun{\argvec{\typename\subi\supeq}{\varbase}{\varbound}}{\alttypename\supeq})}}{\Smalltype}}}
   {\withgenvtypeand{\vvecdef{\alpha\subi}{\Smalltype}{\polybase}{\polybound}}{\tymember{(\tyfun{\argvec{\typename\subi\supeq}{\varbase}{\varbound}}{\alttypename\supeq})}{\Smalltype}}}

%
% This ends the short form scope
%
\end{block}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Atom typing rules
%
\sectionB{Atom typing rules}
\label{section:type-atoms}

\emph{Atoms} represent the values that are used in expressions.  This section
defines the type judgments for atoms.

A variable $v$ has type $t$ only if it is defined with type $t$ in the context.

\minferrule\tyatomvar[Ty-AtomVar]
   {\withgenvtypeand{\vdef{v}{\typename}}{v : \typename}}
   {\withgenvtypeand{\vdef{v}{\typename}}{\diamond}}

%% The ``nil'' atom represents a null value in any type.  There is no guarantee from the FIR semantics
%% that equality computed on two nil values is ever true.  However, nil values are normally implemented by
%% the runtime as zero-arity tuples, and well-typed equality on nil values is normally always true.

%% \nocomment{JYH: we don't have much experience with nil-values, and I'm not confident of the previous
%%   statement.  For example, do we really want to have to check for nil values in ML code?  We
%%   probably want to say that $t$ is limited to only some of the FIR types.  In the meantime, I am
%%   tempted to leave the nil atom out of the presentation.}

%% \minferrule\tyatomnil[Ty-AtomNil]
%%    {\withgenvtype{\atomnil{\typename} : \typename}}
%%    {\withgenvtype{\tymember{\typename}{\Type}}}

Enumerated values represent small, nonnegative numbers.  The value
$\atomenum{i}{j}$ belongs to an enumeration type $\tyenum{i}$, which
represents the values $\mkset{0\ldots i-1}$.  Note that this rule
can never be applied for $\tyvoid$.

\minferrule\tyatomenum[Ty-AtomEnum]
   {\withgenvtype{\atomenum{i}{j} : \tyenum{i}}}
   {j \in \mkset{0\ldots i - 1}
    & \withgenvtype{\tyenum{i} : \Type}}

There are numeric constants for integers, raw integers (integers with various
precision and signedness interpretations), and floating-point values.  The
side conditions $i\in\tyint$, $\rawint\in\tyrawint{\pre}{\sign}$, and
$x\in\tyfloat{\fpre}$ are necessary since syntax alone does not ensure that
these values will be in the type.

\minferrule\tyatomint[Ty-AtomInt]
   {\withgenvtype{\atomint{i} : \tyint}}
   {i \in \tyint
    & \withgenvtype{\diamond}}

\minferrule\tyatomrawint[Ty-AtomRawInt]
   {\withgenvtype{\atomrawint{\rawint}{\pre}{\sign} : \tyrawint{\pre}{\sign}}}
   {\rawint \in \tyrawint{\pre}{\sign}
    & \withgenvtype{\diamond}}

\minferrule\tyatomfloat[Ty-AtomFloat]
   {\withgenvtype \atomfloat{x}{\fpre} : \tyfloat{\fpre}}
   {x \in \tyfloat{\fpre}
    & \withgenvtype{\diamond}}

Labels are used to index frame objects.  Frame objects are viewed as
``unsafe'' data areas, and may be embedded with rawdata areas.  For this
reason, labels are treated as signed constant integers, and may be used as
numbers in arithmetic.

\minferrule\tyatomlabel[Ty-AtomLabel]
   {\withgenvtype{\atomlabel{\tyvar}{\framelabel{f}}{\framelabel{\ms{r}}}{\rawint_\ms{off}} : \tyrawint{32}{\signed}}}
   {\rawint_\ms{off} \in \tyrawint{32}{\signed} &
    \withgenvtype{
        \tyequal
            {\tyapply{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}}
            {\tyframerecord{\framelabel{f} : {\tyrecord{\framelabel{\ms{r}} : t; \ldots}; \ldots}}}
            {\Frametype}}}

The sizeof construction has purpose similar to labels; the value
$\atomsizeof{\cvec{\tyvar\subi}{\varbase}{\varbound}}{r_\ms{size}}$ represents
the sum of the (byte) sizes of the frames defined by
$\cvec{\tyvar\subi}{\varbase}{\varbound}$ and the constant integer
$\rawint_\ms{size}$.  The size itself is determined by the runtime
environment.  The context well-formedness judgment is needed since
$n$ may be $0$.

\minferrule\tyatomsizeof[Ty-AtomSizeof]
   {\withgenvtype{\atomsizeof{\cvec{\tyvar\subi}{\varbase}{\varbound}}{\rawint_\ms{size}} : \tyrawint{32}{\signed}}}
   {\rawint_\ms{size} \in \tyrawint{32}{\signed} &
    \withgenvtype{\lvec{\tymember{\tyvar\subi}{\Typefun{{m\subi}}{\Frametype}}}{\varbase}{\varbound}} &
    \withgenv \diamond}

%
% Note: The i \in {0...n-1} constraint is automagically enforced, because
%       we require the union type to be valid.  We don't need to duplicate
%       that restriction here.
%
Constant atoms correspond to zero-arity elements of unions.  The atom
$\atomconst{u}{\tyvar}{i}$ belongs to a union type
$\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}$ if the
$i^\ms{th}$ case of the union has zero arity.  Note that the rule
\refmath{Ty-Apply-2} requires that the types
$\cvec{t\subi}{\polybase}{\polybound}$ be well formed types in $\Smalltype$.
Also note that the rule implicitly requires
$i\in\mkset{\varbasezero\ldots \varboundzero}$.  Thus, the union type must be
well formed in \refmath{Ty-AtomConst}.

The constant atom is an optimization; zero-arity union cases can also be
allocated using the allocation construction
$\allocunionnoty{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{i}$ (and the
corresponding type rule \refmath{Ty-Alloc-Union}).  However, the runtime
environment normally pre-allocates values for these constant constructors, and
the atom is a convenient reference (although the allocation has the same
semantics).

\iftechreport
\minferrule\tyatomconst[Ty-AtomConst]
   {\withgenvtype{\atomconst{u}{\tyvar}{i} : \tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}}}
   {\begin{array}{l}
    \withgenvtype{\tyequal{u}{\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}}{\Smalltype}}\\
    \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}
                          {\setindex{j}
                           \plusvec{\vec{t}\subi}{\varbasezero}{i-1}
                           + \xvector{}
                           + \plusvec{\vec{t}\subi}{i+1}{\varboundzero}}
                          {\Uniontype{\varbound}}}
    \end{array}}
\else
\minferrule\tyatomconst[Ty-AtomConst]
   {\withgenvtype{\atomconst{t_1}{\tyvar}{i} : \tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}}}
   {\withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}
                          {\setindex{j}
                           \plusvec{\vec{t}\subi}{\varbasezero}{i-1}
                           + \xvector{}
                           + \plusvec{\vec{t}\subi}{i+1}{\varboundzero}}
                          {\Uniontype{\varbound}}}}
\fi

The following three rules represent polymorphic type operations.  These three
rules use type substitution defined in Section~\ref{section:type-subst}.

If $\funname$ is a polymorphic function with type
$\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}$, the type
application $\atomtyapply{u}{\funname}{\cvec{u\subi}{\polybase}{\polybound}}$
represents the function instantiated with type arguments
$\cvec{u\subi}{\polybase}{\polybound}$.


% Emre: When I wrote this comment, it was the case that we're already
%       in the true clause of a \iftechreport...
\iftechreport
\minferrule\tyatomtyapply[Ty-AtomTyApply]
   {\withgenvtype \atomtyapply{u}{\funname}{\cvec{\alttypename\subi}{\polybase}{\polybound}} : \typename[\lvec{\alttypename\subi/\alpha\subi}{\polybase}{\polybound}]}
   {\withgenvtype{\lvec{\alttypename\subi : \Smalltype}{\polybase}{\polybound}}
    & \withgenvtype{\funname : \tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}
    & \withgenvtype{\tyequal{u}{\typename[\lvec{\alttypename\subi/\alpha\subi}{\polybase}{\polybound}]}{\Smalltype}}}
\else
\minferrule\tyatomtyapply[Ty-AtomTyApply]
   {\withgenvtype \atomtyapply{u}{\funname}{\cvec{\alttypename\subi}{\polybase}{\polybound}} : \typename[\lvec{\alttypename\subi/\alpha\subi}{\polybase}{\polybound}]}
   {\withgenvtype{\lvec{\alttypename\subi : \Smalltype}{\polybase}{\polybound}}
    & \withgenvtype{\funname : \tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}}
\fi

A type \emph{pack} construction is the existential introduction from.  It
packages a value with a list of types to form a value with existential type.
The type $\typename$ is a type with (potentially) free type variables
$\cvec{\alpha\subi}{\polybase}{\polybound}$.  If a value $v$ has type
$\typename$ with types $t_i$ substituted for the variables $\alpha_i$, then
$\atomtypack{\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}{v}{\cvec{t\subi}{\polybase}{\polybound}}$
has type $\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}$.

% Emre: When I wrote this comment, it was the case that we're already
%       in the true clause of a \iftechreport...
\iftechreport
\minferrule\tyatomtypack[Ty-AtomTyPack]
   {\withgenvtype{\atomtypack{u}{\varname}{\cvec{\alttypename\subi}{\polybase}{\polybound}} : \tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}}
   {\withgenvtype{\lvec{\alttypename\subi : \Smalltype}{\polybase}{\polybound}}
    & \withgenvtype{\atomvar{\varname} : \typename[\lvec{\alttypename\subi/\alpha\subi}{\polybase}{\polybound}]}
    & \withgenvtype{\tyequal{u}{\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}{\Smalltype}}}
\else
\minferrule\tyatomtypack[Ty-AtomTyPack]
   {\withgenvtype \atomtypack{u}{\varname}{\cvec{\alttypename\subi}{\polybase}{\polybound}} : \tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{\typename}}
   {\withgenvtype \lvec{\alttypename\subi : \Smalltype}{\polybase}{\polybound} &
    \withgenvtype \atomvar{\varname} : \typename[\lvec{t\subi/\alpha\subi}{\polybase}{\polybound}]}
\fi

The \emph{unpack} construction is the corresponding elimination form.  The
unpacking does not introduce new type variables directly; rather, the types
that were packed during existential introduction are referred to by their type
projections.  If $v$ has existential type
$\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{\typename}$,
then $\atomtyunpack{v}$ has type $\typename$ with the type projections
$\typroject{v}{i}$ substituted for $\alpha_i$.  The premise of
\refmath{Ty-AtomTyUnpack} ensures that the type projections $\typroject{v}{i}$
are well-formed.

\minferrule\tyatomtyunpack[Ty-AtomTyUnpack]
   {\withgenvtype \atomtyunpack{\varname} : \typename[\lvec{\typroject{\varname}{\nosubi}/\alpha\subi}{\polybasezero}{\polyboundzero}]}
   {\withgenvtype \atomvar{\varname} : \tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{\typename}}

The final atom values correspond to arithmetic.  The unary rule uses the unary
syntax table defined in Section~\ref{section:fir-unop}.  The
$\unoptyperes{\unop}$ is meta-notation that refers to the result type of the
unary operator, and $\unoptypearg{\unop}$ is the type of the argument.

\minferrule\tyatomunop[Ty-AtomUnop]
   {\withgenvtype \atomunop{\unop}{\atomname} : \unoptyperes{\unop}}
   {\withgenvtype \atomname : \unoptypearg{\unop} &
    \withgenvtype \unoptyperes{\unop} : \Type}

The binary forms are similar.  This rule uses the syntax tables defined in
Section~\ref{section:fir-binop}.  The types $\binoptypearg{\polybase}{\binop}$
and $\binoptypearg{2}{\binop}$ are the types of the argument to the binary
operator $\binop$, and $\binoptyperes{\binop}$ is the type of the result.

\minferrule\tyatombinop[Ty-AtomBinop]
   {\withgenvtype \atombinop{\binop}{\atomnameone}{\atomnametwo} : \binoptyperes{\binop}}
   {\withgenvtype \atomnameone : \binoptypearg{\polybase}{\binop} &
    \withgenvtype \atomnametwo : \binoptypearg{2}{\binop} &
    \withgenvtype \binoptyperes{\binop} : \Type}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Expression typing
%

\sectionB{Expression typing}

\emph{Expressions} form function bodies, and are the primary form used for
program evaluation.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Basic expressions
%
\sectionC{Basic expression typing rules}

\begin{block}
\setalttypename{t_1}
\settypename{t_2}
Operationally, the $\letatom{v}{\alttypename}{\atomname}{e}$ expression evaluates the
atom $\atomname$, binds the variable $v$ to the value, and then evaluates
expression $e$.  The expression has type $\typename$ if the atom has type
$\alttypename$, and the expression $e$ has type $\typename$ when $v$ has type $\alttypename$.

%%% Simple Let expressions and function calls
\minferrule\tyletatom[Ty-LetAtom]
   {\withgenvtype{\letatom{v}{\alttypename}{\atomname}{e : \typename}}}
   {\withgenvtype{\atomname : \alttypename}
    & \withenv{\genvtype, \vdef{v}{\alttypename}}{e : \typename}}
\end{block}

External forms are defined by the runtime environment to access the
runtime or the operating system.  For example, the runtime typically exports
functions to gather statistics and control the garbage collector, and it also
exports a set of system calls.  The description of these functions is specific
to the runtime, and we omit discussion in this paper.  For our purposes, we
assume there is some interpretation $\semleft \text{``s''} \semright$ that
defines a function that corresponds to the runtime operation.

\begin{block}
\setalttypename{t_1}
\settypename{t_2}
\minferrule\tyletext[Ty-LetExt]
   {\withgenvtype{\letext{v}{\alttypename}{s}{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{\alttypename}}{\cvec{\atomname\subi}{\varbase}{\varbound}}{e}:\typename}}
   {\withgenvtype{\lvec{\atomname\subi : u\subi}{\varbase}{\varbound}}
    & \withenv{\genvtype, \vdef{v}{\alttypename}}{e : \typename}
    & \withgenvtype{\semleft \text{``s''} \semright : \tyfun{\argvec{u\subi}{\varbase}{\varbound}}{\alttypename}}}
\end{block}

Tail-calls represent function calls.  This rule assumes that FIR programs use
con\-tin\-ua\-tion-passing-style\footnote{It would be straightforward to add
a returning-function expression.}.  In a tail-call
$\tailcall{\funname}{\cvec{\atomname\subi}{\varbase}{\varbound}}$, the atom
$\funname$ refers to a function that is called with arguments
$\cvec{\atomname\subi}{\varbase}{\varbound}$.  Functions are higher-order, and
may be passed as arguments to other functions, or stored in arrays, tuples, or
other values.  The atom $\funname$ is typically a type application
$\tyapply{f}{\cvec{t\subi}{\polybase}{\polybound}}$ of some function $f$ to
type arguments $\cvec{t\subi}{\polybase}{\polybound}$.

\minferrule\tytailcall[Ty-TailCall]
   {\withgenvtype{\tailcall{\funname}{\cvec{\atomname\subi}{\varbase}{\varbound}}:\tyvoid}}
   {\withgenvtype{\funname : \tyfun{\argvec{\alttypename\subi}{\varbase}{\varbound}}{\tyvoid}}
    & \withgenvtype{\lvec{\atomname\subi : \alttypename\subi}{\varbase}{\varbound}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Special calls
%

%
% End of techreport mode that was started at the beginning of
% context well-formedness.
%
\sectionC{Special-call typing rules}
\else
\sectionB{Special-call typing rules}
\fi
\label{section:special-type-rules}

%
% Emre: ``Interesting'' conditionals...
%

\tronly{Special-calls are expressions for specifying
        process migration and atomic transactions.}
\ifpaper
   The typing rules for special-calls are shown in
   Figure~\ref{figure:special-call-rules}.
\fi
For simplicity, the expression typing rule \refmath{Ty-Special-Call} uses a
common form for all of the special-calls.  If $\tailopname$ is a special-call,
then $\specialcall{\tailopname}$ is an expression.

\ifpaper
   \begin{itemize}
   \item In the
         $\tailsysmigrate{j}{a_\ms{ptr}}{a_\ms{off}}{a_\ms{fun}}{\cvec{a\subi}{\varbase}{\varbound}}$
         special-call expression, the atoms $a_\ms{ptr}$ and $a_\ms{off}$ specify a
         string (as a rawdata block and offset) that describes the migration protocol
         and target (for example, a machine name).  $a_\ms{fun}\left(
         \cvec{a\subi}{\varbase}{\varbound} \right)$ is a tail-call to be performed
         once the process has migrated.  The number $j$ is a unique identifier used by
         the runtime.
   \item The special-call
         $\tailatomic{a_\ms{fun}}{a_\ms{const}}{\cvec{a\subi}{\varbase}{\varbound}}$
         specifies entry into a new atomic transaction.  This operation takes a process
         checkpoint, which can be restored if the transaction is aborted. For typing
         purposes, the atomic call acts exactly like a tail-call to a function
         $a_\ms{fun}$ with arguments $\left( a_\ms{const},
         \cvec{a\subi}{\varbase}{\varbound} \right)$.  For technical reasons, the first
         argument is currently restricted to have type $\tyrawint{32}{\signed}$.
   \item The $\tailatomicrollback{a_\ms{level}}{a_\ms{const}}$ special-call aborts a
         transaction.  It is possible to enter several transactions simultaneously (in
         the source program, transactions are typically nested).  The atom
         $a_\ms{level}$ is an integer that identifies the atomic level, and
         $a_\ms{const}$ is a transaction parameter.
   \item The expression
         $\tailatomiccommit{a_\ms{level}}{a_\ms{fun}}{\cvec{a\subi}{\varbase}{\varbound}}$
         specifies that transaction $a_\ms{level}$ be committed.  Once committed, the
         call acts like the tail-call
         $\tailcall{a_\ms{fun}}{\cvec{a\subi}{\varbase}{\varbound}}$.
   \end{itemize}
\fi

\minferrule\tyspecialcall[Ty-Special-Call]
   {\withgenvtype{\specialcall{\tailopname} : \typename}}
   {\withgenvtype{\tailopname : \tyspecial{\typename}}}

%
% Process migration
%

\iftechreport
   Process migration is specified with the special-call expression
   $\tailsysmigrate{j}{a_\ms{ptr}}{a_\ms{off}}{\funname}{\cvec{a\subi}{\varbase}{\varbound}}$,
   which is described in Section~\ref{section:migration}.  The atoms $a_\ms{ptr}$
   and $a_\ms{off}$ specify a string (as a rawdata block and offset) that
   describes the migration protocol and target (for example, a machine name).
   Section~\ref{section:migration-protocols} describes the possible protocols
   available for system migration.  The $\funname(\cvec{a\subi}{\varbase}{\varbound})$ is a tail-call to be performed
   once the process has migrated.  The number $j$ is a unique identifier used by
   the runtime.
\fi

\minferrule\tysysmigrate[Ty-SysMigrate]
   {\withgenvtype{\tailsysmigrate{j}{\atomname_\ms{ptr}}{\atomname_\ms{off}}{\funname}{\cvec{\atomname\subi}{\varbase}{\varbound}} : \tyspecial{\tyvoid}}}
   {\infertwocolumn{
       &
       \withgenvtype{\atomname_\ms{ptr} : \tyrawdata} \\
       j \in \tyint &
       \withgenvtype{\atomname_\ms{off} : \tyrawint{32}{\signed}}\\
       \withgenvtype{\lvec{\atomname\subi : t\subi}{\varbase}{\varbound}} &
       \withgenvtype{\funname : \tyfun{(\cvec{t\subi}{\varbase}{\varbound})}{\tyvoid} }}}

%
% Atomic entry
%

\iftechreport
   The ``atomic'' special-calls are described in
   Section~\ref{section:transactions}.  The expression
   $\tailatomic{\funname}{a_\ms{const}}{\cvec{a\subi}{\varbase}{\varbound}}$
   specifies entry into a new atomic transaction, which may be later committed or
   rolled back.  The atomic call instructs the runtime to establish a process
   checkpoint that may be used for rollback (or discarded if the transaction is
   committed).  Otherwise, the atomic call acts exactly like a tail-call to a
   function $\funname$ with arguments $\left( a_\ms{const},
   \cvec{a\subi}{\varbase}{\varbound} \right)$.  For technical reasons, the first
   argument is currently restricted to have type $\tyrawint{32}{\signed}$.
\fi

\minferrule\tyatomic[Ty-Atomic]
   {\withgenvtype{\tailatomic{\funname}{\atomname_\ms{const}}{\cvec{\atomname\subi}{\varbase}{\varbound}} : \tyspecial{\tyvoid}}}
   {\withgenvtype{\atomname_\ms{const} : \tyrawint{32}{\signed}}
    & \withgenvtype{\lvec{\atomname\subi : t\subi}{\varbase}{\varbound}}
    & \withgenvtype{\funname : \tyfun{(\tyrawint{32}{\signed},\cvec{t\subi}{\varbase}{\varbound})}{\tyvoid}}}

%
% Atomic rollback
%

\iftechreport
   It is possible to enter several transactions simultaneously (in the source
   program, transactions are typically nested).  Each program checkpoint is
   identified by an integer $a_\ms{level}$\footnote{Atomic levels are described
   in further detail in section \ref{section:transaction-levels}.}.  When a
   transaction at level $a_{\ms{level}}$ is aborted, or ``rolled-back'', all
   transactions with more recent identifiers are discarded and the program state
   is restored to the state immediately \emph{after} entry into the transaction.  If the transaction
   was initiated with
   $\tailatomic{a_\ms{fun}'}{a_\ms{const}'}{\cvec{a\subi'}{\varbase}{\varbound}}$,
   the $\tailatomicrollback{a_\ms{level}}{a_\ms{const}}$ special-call expression
   resumes execution with a tail-call to $\tailcall{a_\ms{fun}'}{a_\ms{const},
   \cvec{a\subi'}{\varbase}{\varbound}}$.
\fi

\minferrule\tyatomicrollback[Ty-AtomicRollback]
   {\withgenvtype{\tailatomicrollback{\atomname_\ms{level}}{\atomname_\ms{const}} : \tyspecial{\tyvoid}}}
   {\withgenvtype{\atomname_\ms{level} : \tyrawint{32}{\signed}}
    & \withgenvtype{\atomname_\ms{const} : \tyrawint{32}{\signed}}}

%
% Atomic commit
%

\iftechreport
   Transactions can be committed in any order.  The expression
   $\tailatomiccommit{a_\ms{level}}{\funname}{\cvec{a\subi}{\varbase}{\varbound}}$
   specifies that transaction $a_\ms{level}$ be committed.  Committing a
   transaction instructs the runtime to discard the program checkpoint identified
   by $a_\ms{level}$.  Once committed, the commit call acts like the tail-call
   $\tailcall{\funname}{\cvec{a\subi}{\varbase}{\varbound}}$.
\fi

\minferrule\tyatomiccommit[Ty-AtomicCommit]
   {\withgenvtype{\tailatomiccommit{\levelname}{\funname}{\cvec{\atomname\subi}{\varbase}{\varbound}} : \tyspecial{\tyvoid}}}
   {\withgenvtype{\levelname : \tyrawint{32}{\signed}}
    & \withgenvtype{\lvec{\atomname\subi : t\subi}{\varbase}{\varbound}}
    & \withgenvtype{\funname : \tyfun{\argvec{t\subi}{\varbase}{\varbound}}{\tyvoid}}}

%
% If this is not a tech report, place special calls in
% a table.
%
\ifpaper
   \makefiguretwocolumn{figure:special-call-rules}{Special-call type rules}{%
   \renewcommand\arraystretch{3}
   $$
   \begin{array}{c}
   \tysysmigrate\\
   \tyatomic\\
   \tyatomicrollback\\
   \tyatomiccommit\\
   \tyspecialcall
   \end{array}
   $$}
\fi

%
% Now we omit everything up to subscripting from the POPL paper.
%
\iftechreport

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Match statement typing rules
%
\sectionC{Match statement typing rules}

Match statements allow pattern matching on numbers, where a pattern is defined
as a set of constant intervals (patterns do not contain variables).  The type
of the atom being analyzed determines the rule to apply.  A match statement
with zero cases is not allowed; the type of the atom must contain at least one
value. In addition, partial match statements are not allowed; the union of the
sets must cover all possible values for the type of the atom.

The following three rules are similar.  Operationally, a match expression
$\matchstmt{\atomname}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}}$
chooses the first expression $e_i$ for evaluation where $a \in s_i$.  The
match expression has type $t$ if \emph{all} of the expressions $e_i$ have type
$t$, and the sets $s_i$ cover all of the possible values for the match
argument $\atomname$.

\minferrule\tymatchint[Ty-Match-Int]
   {\withgenvtype \matchstmt{\atomname}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}} : \typename}
   {\lvec{s\subi \in \intset}{\varbase}{\varbound}
    & \bigcup_{\xxxindex = 1}^n s_{\xxxindex} = \tyint
    & \withgenvtype \atomname : \tyint
    & \withgenvtype \lvec{e\subi : \typename}{\varbase}{\varbound}}

\minferrule\tymatchenum[Ty-Match-Enum]
   {\withgenvtype \matchstmt{\atomname}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}} : \typename}
   {j > 0
    & \lvec{s\subi \in \intset}{\varbase}{\varbound}
    & \bigcup_{i=1}^n s_i = \tyenum{j}
    & \withgenvtype \atomname : \tyenum{j}
    & \withgenvtype \lvec{e\subi : \typename}{\varbase}{\varbound}}

\minferrule\tymatchrawint[Ty-Match-RawInt]
   {\withgenvtype \matchstmt{\atomname}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}} : \typename}
   {\lvec{s\subi \in \rawintset}{\varbase}{\varbound}
    & \bigcup_{i=1}^n s_i = \tyrawint{\pre}{\sign}
    & \withgenvtype \atomname : \tyrawint{\pre}{\sign}
    & \withgenvtype \lvec{e\subi : \typename}{\varbase}{\varbound}}

The match case for unions is a special case.  A value $v$ of type
$\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{s_\ms{union}}$ belongs
to some union space $\plusvec{\vec{t}\subi}{\varbase}{\varbound}$.  The actual
value for $v$ belongs to exactly one of the cases in the union, and the
$\matchstmt{\atomvar{v}}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}}$
expression is the elimination form.  For the match statement to be
well-formed, the atom $v$ must be a variable with a valid union type
restricted to cases $s_\ms{union}$.  The match cases $s_i$ must include all of
the possible values in $s_\ms{union}$.  For case $\matchcase{s_j}{e_j}$, the
expression $e_j$ must be well-typed given the \emph{restricted} type
$\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{s_j}$ for $v$.

\minferrule\tymatchunion[Ty-Match-Union]
   {\withgenvtypeand{\vdef{v}{\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{s_\ms{union}}}}
      \matchstmt{\atomvar{v}}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}} : \typename}
   {\lvec{s\subi \in \intset}{\varbase}{\varbound}
    & \mkset{} \not= s_\ms{union} = \bigcup_{\xxxindex=1}^n s_\xxxindex
    & \lvec{\withgenvtypeand{\vdef{v}{\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{s\subi}}}{e\subi : \typename}}{\varbase}{\varbound}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Allocation typing rules
%
\sectionC{Allocation typing rules}

For memory operations, we define two short-hand macros that specify
information on the offset atoms.  Some operations permit an integer or a
variable offset, which must have type $\tyint$ or $\tyrawint{32}{\signed}$;
this alternation is expressed with the $\indextype$ macro.  Other operations
restrict the offset atom to be a constant; these use the $\indexatom{c}{i}$
macro, where $c$ is a $\tupleclass$ and $i$ is a word offset into a tuple.
Note that $\wordsize$ is a constant, and indicates the size of a word on the
architecture.

$$
\begin{array}{rcl}

\indextype & = & \tyint \vbar \tyrawint{32}{\signed} \\

% NOTE: This is a bit subtle, because if we have a boxed tuple,
%       we don't restrict i to be zero.  However, in the subscript
%       rules, we require that i is in {0,sizeof_tuple - 1}, and
%       for boxed tuples, sizeof_tuple = 1.  Pretty neat, eh? :)
\indexatom{c}{i} & = &
   \begin{cases}
      \atomint{i} \vbar \atomrawint{i \cdot \wordsize}{32}{\signed} &  \text{when $c = \normaltuple$} \\
      \atomint{0} \vbar \atomrawint{0}{32}{\signed}                 &  \text{when $c = \boxedtuple$}
   \end{cases}

\end{array}
$$

\begin{block}
For simplicity, the allocation typing rule uses a common form for all of the
allocation operators.  If $\allocopname$ is an allocation of type
$\tyalloc{\alttypename}$, and $e$ is well-typed under the assumption that $v$ has type
$\alttypename$, then $\letalloc{v}{\allocopname}{e} : \typename$ is a well-typed allocation
expression.

\minferrule\tyletalloc[Ty-Alloc]
   {\withgenvtype{\letalloc{v}{\allocopname}{e} : \typename}}
   {\withgenvtype{\allocopname : \tyalloc{\alttypename}}
    & \withgenvtypeand{\vdef{v}{\alttypename}}{e : \typename}}
\end{block}

There are five allocation operations, corresponding to the five different
kinds of aggregate values: tuples, arrays, unions, rawdata, and
frames\footnote{For readability, we shorten
$\alloctuple{c}{t}{\cvec{\atomname\subi}{\varbase}{\varbound}}$ to
$\alloctuplenoty{c}{\cvec{a\subi}{\varbase}{\varbound}}$ in this section.  The
same is done for the union, frame, and rawdata allocation operators.  The type
$t$ in these operators (that is dropped) is the same as the type given to the
operator by the typing rules.}.

Tuples are allocated with
$\alloctuplenoty{c}{\cvec{\atomname\subi}{\varbase}{\varbound}}$, where
$\cvec{\atomname\subi}{\varbase}{\varbound}$ are the initial values in the
tuple, and $c$ is the tuple class.

\minferrule\tyalloctuple[Ty-Alloc-Tuple]
   {\withgenvtype{\alloctuplenoty{c}{\cvec{\atomname\subi}{\varbase}{\varbound}} : \tyalloc{\tytuple{c}{\cvec{u\subi}{\varbase}{\varbound}}}}}
   {\withgenvtype{\lvec{\atomname\subi : u\subi}{\varbase}{\varbound}} &
    \withgenvtype{\tytuple{c}{\cvec{u\subi}{\varbase}{\varbound}} : \Smalltype}}

Arrays are allocated by specifying the number $\sizename_\ms{size}$ of
elements in the array, and the initial value $\atomname_\ms{init}$ for all the
elements in the array.

\minferrule\tyallocarray[Ty-Alloc-Array]
   {\withgenvtype{\allocarraynoty{\sizename_\ms{size}}{\atomname_\ms{init}} : \tyalloc{\tyarray{\alttypename}}}}
   {\withgenvtype{\sizename_\ms{size} : \indextype}
    & \withgenvtype{\atomname_\ms{init} : \alttypename}}

Unions are allocated with the form
$\allocunionnoty{\tyvar}{\cvec{a\subi}{\polybase}{k}}{j}$, where $\tyvar$ must
be a union; union case $j$ must be a tuple
$\xvector{\cvec{u\subi}{\polybase}{k}}$ with arity $k$, and value $a_i$ must
have type $u_i$.  The rule here defers to the \refmath{Ty-StoreUnion} to spell
out these requirements---the allocation is well-formed if the resulting store
value is well-formed.

\minferrule\tyallocunion[Ty-Alloc-Union]
   {\withgenvtype{\allocunionnoty{\tyvar}{\cvec{a\subi}{\polybase}{k}}{j}
              : \tyalloc{\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{j}}}}}
   {\withgenvtype{\storeunion{\tyvar}{j}{\cvec{a\subi}{\polybase}{k}} : \tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{j}}}}

The malloc form $\allocmallocnoty{\atomname}$ is used to allocate rawdata
blocks.  The atom $\atomname$ is the minimum number of bytes in the rawdata area.

\minferrule\tyallocmalloc[Ty-Alloc-Malloc]
   {\withgenvtype{\allocmallocnoty{\atomname} : \tyalloc{\tyrawdata}}}
   {\withgenvtype{\atomname : \indextype}}

Frame allocation using the form
$\allocframe{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}$ is similar to
rawdata allocation, in that it doesn't specify the initial values in the
frame.  The allocation is well-formed if the type
$\tyframe{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}$ is well-formed.  The
number of bytes allocated is at least $\atomsizeof{\tyvar}{\polybase}$.

\minferrule\tyallocframe[Ty-Alloc-Frame]
   {\withgenvtype{\allocframe{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}} : \tyalloc{\tyframe{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}}}}
   {\withgenvtype{\tyframe{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}} : \Smalltype}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Subscript typing rules
%

%
% End of tech report mode that we started up near match statments
%
\sectionC{Subscripting typing rules}
\else
\sectionB{Subscripting typing rules}
\fi

Elements in the aggregate types
\iftechreport
   (tuples, arrays, unions, rawdata, and frames)
\else
   (tuples, arrays, unions, and rawdata)
\fi
are accessed using the $\letsubscript{v}{t_1}{\arrayname}{\offsetname}{e}$ expression.  All
entries in aggregate blocks are mutable; an entry is replaced using the
$\setsubscript{\arrayname}{\offsetname}{t_1}{\elemname}{e}$ expression.
\iftechreport
   % No text necessary.
\else
   For this \papername, we consider the rules for subscripting operations
   on tuple and rawdata aggregates, shown in
   Figure~\ref{figure:subscript-types}.
\fi

In general, $\letsubscript{v}{t_1}{\arrayname}{\offsetname}{e}$ is a well-formed expression
if all of the following are true.

\begin{itemize}
\setlength{\itemsep}{0in}
\item The atom $\arrayname$ has an aggregate type.
\item The atom $\offsetname$ is a valid index into $\arrayname$.
\item The element of $\arrayname$ at location $\offsetname$ has type $t_1$.
\item Expression $e$ is well-formed assuming $v$ has type $t_1$.
\end{itemize}

Similarly, $\setsubscript{\arrayname}{\offsetname}{t_1}{\elemname}{e}$ is well-formed if the
following are true.

\begin{itemize}
\setlength{\itemsep}{0in}
\item The atom $\arrayname$ has aggregate type.
\item The atom $\offsetname$ is a valid index into $\arrayname$.
\item The element of $\arrayname$ at location $\offsetname$ has type $t_1$.
\item The atom $\elemname$ has type $t_1$.
\item Expression $e$ is well-formed (with no extra assumptions).
\end{itemize}

%
% Tuples are included in the POPL paper.
%

For the subscripting operation $\arrayname[\offsetname]$ on tuple aggregates, the index
$\offsetname$ must be a constant $j$.  If the tuple $\arrayname$ has type
$\tytuple{c}{\cvec{u\subi}{0}{n-1}}$, the element has type $u_j$.

\minferrule\tyletsubtuple[Ty-LetSub-Tuple]
   {\withgenvtype{\letsubscript{v_1}{\alttypename}{\arrayname}{\indexatom{c}{j}}{e} : \typename}}
   {\withgenvtype{\arrayname : \tytuple{c}{\cvec{u\subi}{\varbasezero}{j-1}, \alttypename, \cvec{u\subi}{j+1}{\varboundzero}}}
    & \withenv{\genvtype, \vdef{v_1}{\alttypename}}{e : \typename}}

\minferrule\tysetsubtuple[Ty-SetSub-Tuple]
   {\withgenvtype{\setsubscript{\arrayname}{\indexatom{c}{j}}{\alttypename}{\elemname}{e} : \typename}}
   {\withgenvtype{\arrayname : \tytuple{c}{u_\varbasezero, \ldots, u_{j-1}, \alttypename, u_{j+1}, \ldots, u_\varboundzero}}
   & \withgenvtype{\elemname : \alttypename}
   & \withgenvtype{e : \typename}}

\iftechreport
   Unlike tuples, all the elements in an array have the same type.  The
   subscripting operation $a_1[a_2]$ is well-formed if the index $a_2$ is a valid
   index, the aggregate $a_1$ has array type $\tyarray{u}$, and the element
   being accessed has type $u$.
\fi

\minferrule\tyletsubarray[Ty-LetSub-Array]
   {\withgenvtype{\letsubscript{v}{\alttypename}{\arrayname}{\offsetname}{e : \typename}}}
   {\withgenvtype{\arrayname : \tyarray{\alttypename}}
    & \withgenvtype{\offsetname : \indextype}
    & \withenv{\genvtype, \vdef{v}{\alttypename}}{e : \typename}}

\minferrule\tysetsubarray[Ty-SetSub-Array]
   {\withgenvtype \setsubscript{\arrayname}{\offsetname}{\alttypename}{\elemname}{e : \typename}}
   {\withgenvtype{\arrayname : \tyarray{\alttypename}}
    & \withgenvtype{\offsetname : \indextype}
    & \withgenvtype{\elemname : \alttypename}
    & \withgenvtype{e : \typename}}

\iftechreport
   Union operations are somewhat more complicated.  For the subscripting
   operation $\arrayname[\offsetname]$ to be well-formed, the aggregate $\arrayname$ must belong to a
   \emph{specific} case $\vec{u}_j$ in some union type
   $\plusvec{\vec{u}\subi}{\varbasezero}{\varboundzero}$.  The index $\offsetname$ must
   be a constant $k$.  The type list $\vec{u}_j$ must be a vector
   $\xvector{\cvec{u'\subi}{0}{l-1}}$, and the element being accessed must have
   type $u'_k$.
\fi

\minferrule\tyletsubunion[Ty-LetSub-Union]
   {\withgenvtype{\letsubscript{v}{\alttypename}{\arrayname}{\indexatom{\normaltuple}{k}}{e : \typename}}}
   {\begin{array}{l}
      \withgenvtype{\arrayname : \tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}{\mkset{j}}} \\
      \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}}
                            {\left(
                             \lvec{\vec{u}\subi}{\varbasezero}{j-1}
                             + \xvector{\lvec{u'\subi}{0}{k-1}, \alttypename, \lvec{u'\subi}{k+1}{l-1}}
                             + \lvec{\vec{u}\subi}{j+1}{\varboundzero}
                             \right)}
                            {\Uniontype{\varbound}}}\\
      \withgenvtypeand{\vdef{v}{\alttypename}}{e : \typename}
    \end{array}}

\minferrule\tysetsubunion[Ty-SetSub-Union]
   {\withgenvtype{\setsubscript{\arrayname}{\indexatom{\normaltuple}{k}}{\alttypename}{\elemname}{e} : \typename}}
   {\begin{array}{l}
      \withgenvtype{\arrayname : \tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}{\mkset{j}}} \\
      \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}}
                            {\left(
                             \lvec{\vec{u}\subi}{\varbasezero}{j-1}
                             + \xvector{\lvec{u'\subi}{0}{k-1}, \alttypename, \lvec{u'\subi}{k+1}{l-1}}
                             + \lvec{\vec{u}\subi}{j+1}{\varboundzero}
                             \right)}
                            {\Uniontype{\varbound}}}\\
      \withgenvtype{\elemname : \alttypename}\\
      \withgenvtype{e : \typename}
    \end{array}}

%
% Include the following in the POPL paper (sorta).
%

For load/store operations on $\tyrawdata$, the type of value being accessed is
not determined by the typing rules.
\iftechreport
   The $\tyrawdata$ type is used primarily for C programs, which allows data in
   memory to be manipulated with arbitrary types.  For safety, the runtime
   environment generates a runtime safety check to verify that the value being
   accessed has a compatible type.
\fi

\minferrule\tyletsubrawdata[Ty-LetSub-RawData]
   {\withgenvtype{\letsubscript{v}{\alttypename}{\arrayname}{\offsetname}{e : \typename}}}
   {\withgenvtype{\arrayname : \tyrawdata}
    & \withgenvtype{\offsetname : \indextype}
    & \withenv{\genvtype, \vdef{v}{\alttypename}}{e : \typename}}

\minferrule\tysetsubrawdata[Ty-SetSub-RawData]
   {\withgenvtype{\setsubscript{\arrayname}{\offsetname}{\alttypename}{\elemname}{e : \typename}}}
   {\withgenvtype{\arrayname : \tyrawdata}
    & \withgenvtype{\offsetname : \indextype}
    & \withgenvtype{\elemname : \alttypename}
    & \withgenvtype{e : \typename}}

\iftechreport
   Frames are similar to rawdata, in that the runtime generates runtime safety
   checks because frames are allocated uninitialized.  Otherwise, a subscript
   operation $a_1[a_2]$ is well formed if $a_2$ is a two-level label $\left<
   \framelabel{f}, \framelabel{r} \right>$, $a_1$ is a frame, and the element
   being accessed has the same type as the field
   $a_1.\framelabel{f}.\framelabel{r}$.
\fi

\minferrule\tyletsubframe[Ty-LetSub-Frame]
   {\withgenvtype{\letsubscript{v}{\alttypename}{\arrayname}{\atomlabel{\tyvar}{\framelabel{f}}{\framelabel{\ms{r}}}{\rawint_\ms{off}}}{e : \typename}}}
   {\begin{array}{l}
      \rawint_\ms{off} \in \tyrawint{32}{\signed} \\
      \withgenvtype{\arrayname : \tyframe{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}} \\
      \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}}
                            {\tyframerecord
                                {\framelabel{f} : \tyframerecord{\framelabel{\ms{r}} : \alttypename; \cdots}; \cdots}}
                            {\Frametype}}\\
      \withgenvtypeand{\vdef{v}{\alttypename}}{e : \typename}
    \end{array}}

\minferrule\tysetsubframe[Ty-SetSub-Frame]
   {\withgenvtype{\setsubscript{\arrayname}{\atomlabel{\tyvar}{\framelabel{f}}{\framelabel{\ms{r}}}{\rawint_\ms{off}}}{\alttypename}{\elemname}{e} : \typename}}
   {\begin{array}{l}
      \rawint_\ms{off} \in \tyrawint{32}{\signed} \\
      \withgenvtype{\arrayname : \tyframe{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}} \\
      \withgenvtype{\tyequal{\tyapply{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}}
                            {\tyframerecord
                                {\framelabel{f} : \tyframerecord{\framelabel{\ms{r}} : \alttypename; \cdots}; \cdots}}
                            {\Frametype}}\\
      \withgenvtype{\elemname : \alttypename}\\
      \withgenvtype{e : \typename}
    \end{array}}

%
% Make the rules into a figure for the POPL paper.
%
\ifpaper
   \makefiguretwocolumn{figure:subscript-types}{Subscript type rules}{%
   $$
   \renewcommand\indexatom[2]{#2}
   \renewcommand\indextype{\tyrawint{32}{\signed}}
   \renewcommand{\arraystretch}{3}
   \begin{array}{l}
   \tyletsubtuple\\
   \tysetsubtuple\\
   \tyletsubrawdata\\
   \tysetsubrawdata
   \end{array}
   $$}
\fi

%
% Everything else is ommitted from the POPL paper.
%
\iftechreport

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Globals
%
\sectionC{Global label typing rules}

Global values are represented directly in the context using a label $\xlabel$.
For global operations to be well-formed, the label
$\xlabel$ must be a valid global label with type $t$.

\minferrule\tylabel[Ty-Label]
   {\withgenvtypeand{\vdef{\xlabel}{t}}{\xlabel : t}}
   {\withgenvtypeand{\vdef{\xlabel}{t}}{\diamond}}

Labels are \emph{not} variables; there is no atom that allows global values to be used directly.
The value in a global is loaded with the $\letglobal{v}{t_1}{\xlabel}{e}$ expression, and stored
with the $\setglobal{\xlabel}{t_1}{\atomname}{e}$ expression.

\minferrule\tyletglobal[Ty-LetGlobal]
   {\withgenvtype{\letglobal{v}{\alttypename}{\xlabel}{e} : \typename}}
   {\withgenvtype{\xlabel : \alttypename}
    & \withenv{\genvtype, \vdef{v}{\alttypename}} e : \typename}

\minferrule\tysetglobal[Ty-SetGlobal]
   {\withgenvtype{\setglobal{\xlabel}{\alttypename}{\atomname}{e : \typename}}}
   {\withgenvtype{\xlabel : \alttypename}
    & \withgenvtype{\atomname : \alttypename}
    & \withgenvtype{e : \typename}}

%
% End of tech report mode (started just before the global rules section)
%
\fi

% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
